package de.intevation.flys.artifacts.model.minfo;

import gnu.trove.TDoubleArrayList;


public class BedHeightSingle
extends BedHeight
{

    protected int year;
    protected TDoubleArrayList data_gap;
    protected TDoubleArrayList morphWidth;

    public BedHeightSingle() {
        super();
        this.year = -1;
        data_gap = new TDoubleArrayList();
        morphWidth = new TDoubleArrayList();
    }

    public BedHeightSingle(String name) {
        super(name);
        this.year = -1;
        data_gap = new TDoubleArrayList();
        morphWidth = new TDoubleArrayList();
    }

    public void add(
        double value,
        double station,
        double gap,
        double width,
        int year
    ) {
        super.add(value, station);
        this.year = year;
        this.data_gap.add(gap);
        this.morphWidth.add(width);
    }

    public int getYear() {
        return this.year;
    }

    public double getMorphWidth(int idx) {
        return this.morphWidth.get(idx);
    }

    public double getDataGap(int idx) {
        return this.data_gap.get(idx);
    }

    public double getMorphWidth(double station) {
        if (this.station.indexOf(station) >= 0) {
            return this.morphWidth.get(this.station.indexOf(station));
        }
        return Double.NaN;
    }

    public double getDataGap(double station) {
        if (this.station.indexOf(station) >= 0) {
            return this.getDataGap(this.station.indexOf(station));
        }
        return Double.NaN;
    }

    public double[] getMorphWidths() {
        return this.morphWidth.toNativeArray();
    }
}
